#include "FTprocedure.h"


//apre una socket per gestire il FT e richiude il tutto
//ritorna:
// 0 in caso di download corretto
//-1 in caso di mancata apertura del file dest
//-2 in caso di failure della reconnect
//-3 in caso di download incompleto
//-4 vari ed eventuali   
int FTClientProcedure(string serv_haddr, int serv_hport, string localfilename, int remotefilesize, int openflag)
{
	//preparo l' addr del server e la socket
	SA_IN servaddr;
	memset(&servaddr,0,sizeof(servaddr));
	servaddr.sin_family = AF_INET;
	servaddr.sin_port = htons(serv_hport);
	inet_pton(AF_INET,serv_haddr.c_str(),&servaddr.sin_addr);
#ifdef _DEBUG
cout<<"FTclientproc connect: "<<serv_haddr<<":"<<serv_hport<<endl;	
#endif
	SOCKDESCR ftsock = Socket(AF_INET,SOCK_STREAM,0);
	
	//preparo il destination file
	
	int destfiled;
	/*
	umask(0);
	switch(openflag){
		case OVERWRITE:
			if( (destfiled = open(localfilename.c_str(),O_CREAT,S_IRWXU)) == -1){
				cerr<<"Unable to open localfile"<<endl;
				perror("");
				Close(ftsock);
				return -1;
			}
		break;
		case CREATE_TEMPFILE:{
			if( (destfiled = open(localfilename.c_str(),O_CREAT|O_EXCL,S_IRWXU)) == -1){
				if(errno == EEXIST){
					int randnum = 1+(int)((MAX_FILENAME_NUM)*(float)rand()/(RAND_MAX +1.0));
					ostringstream is;
					is<<randnum;
					localfilename = TEMP_FILENAME + is.str();
					cout<<"Duplicate name for local file. Using file name: "<<localfilename;
					if( (destfiled = open(localfilename.c_str(),O_CREAT|O_EXCL,S_IRWXU)) == -1){
						cerr<<"Unable to open destination file"<<endl;
						Close(ftsock);
						return -1;
					}
				}else{
					cerr<<"Unable to open destination file"<<endl;
					Close(ftsock);
					return -1;
				}
			}
		}break;
		default:{
			cerr<<"openflag not properly set"<<endl;
			exit(-1);
		}
	}
	*/
	umask(0);
	destfiled = open(localfilename.c_str(),O_CREAT|O_WRONLY,S_IRWXU);
	//OK, file aperto epronto all' uso
	//connettiamo e leggiamo
	if( (ftsock = Reconnect(ftsock,(SA *) &servaddr,sizeof(servaddr),MAXRESUME)) == -1){
		cerr<<"Unable to Connect to server... aborting FT"<<endl;
		Close(ftsock);
		return -2; 
	}
	//ok connesso! adesso leggo dalla cosket
	cout<<"Downloadin file"<<endl;
	int byteread = 0;
	int totalbyteread = 0;
	char buffer[MAXBUFFER];
	while( (byteread = Readn(ftsock,buffer,MAXBUFFER)) > 0){
		write(destfiled,buffer,byteread);
		totalbyteread += byteread;
		cout<<"Progress: "<<totalbyteread<<" downloaded bytes\r";
	}
	cout<<endl;
	close(destfiled);
	Close(ftsock);
	cout<<endl;
	//ok qui il server ha chiuso la connessione. controllo se tutto e' Ok
	if(totalbyteread == remotefilesize){
		cout<<"Download completed successfully!"<<endl;
		return 0;
	} else {
		cout<<"something was wrong with download. Removing file"<<endl;
		if(remove(localfilename.c_str()) == -1)
			cerr<<"error removing corrupted downloaded file"<<endl;
		return -3;
	}
}
//--------------------------------------------------------------------------
//per il server ci sono solo due conclusioni:
// 0 dl completato con successo
//-1 fallito
int FTServerProcedure(SOCKDESCR listensock, string filename, int filesize, int flag)
{
	//chiamo la accept e chiudo la listensock
	SA_IN remoteaddr;
	socklen_t remoteaddrlen;
	SOCKDESCR ftsock = Accept(listensock,(SA *)&remoteaddr,&remoteaddrlen);
	Close(listensock);
	//ok adesso siamo connessi!
	//diamo inizio alle danze!!!

#ifdef _DEBUG	
cout<<"FTserver connected correctly for DL. ftsock = "<<ftsock<<endl;
cout<<"FTserver is uploading file: "<<filename<<" of length: "<<filesize<<endl;
#endif

	int openfd = 0;
	if( (openfd = open(filename.c_str(),O_RDONLY)) == -1){
		perror("transfer file server routine");
		Close(ftsock);
		sleep(10);
		return -1;
	} 	
	int byteread = 0;
	int totalbyte = 0;
	char buffer[MAXBUFFER];
	while( (byteread = read(openfd,buffer,MAXBUFFER)) > 0){
		//in buffer ci sono i byte letti ora scrivo nella socket
		if(byteread == -1){
			perror("transfer file routine");
			Close(ftsock);
			sleep(10);
			return -1;
		}
		totalbyte += byteread;
		Writen(ftsock,buffer,byteread);
	}
	Close(ftsock);
	close(openfd);
	
	if(totalbyte< filesize){
		cerr<<"FTServerProcedure: I read less byte than reported by stat. return -1"<<endl;
		return -1;
	}
	return 0;
}
//--------------------------------------------------------------------------