//client generico per il progetto
#include "project.h"
#include "processfile.h"
#include "fedcli_proc.h"

//---------------------------------------
int ProcessClientCommand(Tcommandtable commandtable, string commandstring, Tcommandstruct &command)
{
	istringstream is(commandstring);
	string comm; is>>comm;
	command.arg1 = command.arg2 = command.arg3 = "";
	switch(commandtable[comm]){
		case CLICOMM_LIST:{
			command.id = CLICOMM_LIST;
			return command.id;
		}break;	
		case CLICOMM_SHOW_LIST:{
			command.id = CLICOMM_SHOW_LIST;
			return command.id;
		}break;
		case CLICOMM_GET:{
			cout<<"  remotefilename: "; cin>>command.arg1;
			cout<<"  localfilename : "; cin>>command.arg2;
			command.id = CLICOMM_GET;
			return command.id;
		}break;
		case CLICOMM_PUT:{
			cout<<"  localfilename: "; cin>>command.arg1;
			cout<<"  remotefilename : "; cin>>command.arg2;
			command.id = CLICOMM_PUT;
			return command.id;
		}break;
		case CLICOMM_DELETE:{
			cout<<"  remotefilename"; cin>>command.arg1;
			command.id = CLICOMM_DELETE;
			return command.id;
		}break;
		case CLICOMM_LOCK:{
			cout<<"  remotefilename"; cin>>command.arg1;
			command.id = CLICOMM_LOCK;
			return command.id;
		}break;
		case CLICOMM_UPDATE:{
			cout<<"  remotefilename"; cin>>command.arg1;
			command.id = CLICOMM_UPDATE;
			return command.id;
		}break;
		case CLICOMM_DISCONNECT:{
			command.id = CLICOMM_DISCONNECT;
			return command.id;
		}
		default:{
			cout<<"  BAD command. retype"<<endl;
			command.id = CLICOMM_UNKNOWN;
			return command.id;
		}
	}
}
//--------------------------------------

//**************************************
//variabili statiche usate per il REDIR
//devono essere dichiarate extern nell' header del
//

//************************************
int main(int argc, char **argv)
{
string redir_ipaddr = "";
int    redir_ipport   = 0;
	
	string servdbname = CLIENT_SERVER_FILENAME;
	string currservaddr;
	int    currservport;
	Tservtable servtable;
	SA_IN servaddr;
	
	memset(&servaddr,0,sizeof(servaddr));
	servaddr.sin_family = AF_INET;
	currservport = SERVER_FOR_CLIENT_PORT;
	servaddr.sin_port = htons(currservport); //default server port
	
	SOCKDESCR sockfd = -1;
	//////////////////////////////TEST ONLY/////////////////////////////
	if(argc > 1){
		if( (sockfd = Socket(AF_INET,SOCK_STREAM,0)) == -1){
			perror("Client CANNOT start up");
			exit(-1);
		}
		currservport = atoi(argv[2]);
		servaddr.sin_port = htons(currservport); //htons(atoi(argv[2]));
		currservaddr = argv[1];
		inet_pton(AF_INET,argv[1],&servaddr.sin_addr);
		
		if( (sockfd = Reconnect(sockfd, (SA *) &servaddr,sizeof(servaddr),MAX_RESUME_TIME)) == -1){
			cout<<"I CANNOT CONNECT TO ANY SERVER. Exiting..."<<endl;
			exit(-1);
		}	
/////////////////////////////////////////////////////////////////////////		
	}else{
		//si connette leggendo il fserver.db
		cout<<"reading serv data base file: "<<servdbname<<endl;

		if(!FillServTable(servtable,servdbname)){
			cerr<<"error opening server detabase. exiting..."<<endl;
			exit(-1);
		}
		#ifdef _DEBUG
		cout<<"finisched reading serv.db"<<endl;
		cout<<"servtable size: "<<servtable.size()<<endl;
		#endif
		
		sockfd = -1;
		if( (sockfd = GetServerConnection(sockfd,servaddr,servtable)) == -1){
			cout<<"Sorry, I CANNOT connect to any server. Exiting..."<<endl;
			exit(-1);
		}
	}
	//ok se raggiungo questo punto ho una connessione attiva e valida
	//nella servaddr ho l'addr del server attivo;
	//metto su il ciclo infinito di lettura comandi
	Tstringlist filelist;
	Tcommandset commandset;
	Tcommandtable commandtable;
	InitCommandSet(commandset,commandtable);
	bool askforcomm = false;
#ifdef _DEBUG
cout<<"inoltro la richiesta di lista per i file"<<endl;
sleep(1);
#endif
	string commandstring = "list";
	Tcommandstruct command;
	command.id = 0; command.arg1 = ""; 
	command.arg2 = "";	command.arg3 = "";
	for(;;){
		if(askforcomm){
			cout<<COMMAND_PROMPT<<" ";
			cin>>commandstring;
		}	
		int command_id = ProcessClientCommand(commandtable,commandstring,command);
#ifdef _DEBUG
cout<<"command recognized: "<<command_id<<endl;
#endif
		switch(command_id){
			case CLICOMM_SHOW_COMMANDSET:{  //help[A
				ShowCommandSet(commandset);
				askforcomm = true;
				commandstring = "";
			}break;
			
			case CLICOMM_SHOW_HELP:{ //help <command>
				ShowCommandSet(commandset,command.arg1);
				askforcomm = true;
				commandstring = "";
			}break;
			
			case CLICOMM_SHOW_LIST:{ //showlist
				ShowFileList(filelist);
				askforcomm = true;
				commandstring = "";
			}break;
///////////////////////////		
			case CLICOMM_LIST:{  //list
				int result = ExecuteListCommand(sockfd);
				switch(result){
					case 0:{		//la lista e' stata ricevuta correttamente
						cout<<"refreshing list"<<endl;
						RefreshFileList(filelist);
						cout<<"List downloaded Successfully. Show it now [y/n]?";
						string answer;
						cin>>answer;
						if(answer == "y"){
							askforcomm = false;
							commandstring = "showlist";
						} else askforcomm = true;
					}
					break;
					
					case -1:{ //denied
						#ifdef _DEBUG
						cout<<"CLICOMM_LIST denied"<<endl;
						#endif
						cout<<"Server DENY file list access. Try again? [y/n] ";
						string askfordeny;
						cin>>askfordeny;
						if(askfordeny == "y"){
							askforcomm = false;
							commandstring = "list";
							cout<<"five seconds wait"<<endl;
							sleep(5);
						} else {
							askforcomm = true;
							commandstring = "";
						}
					}
					break;
					
					case -2:{ //connection refused-->redirect
						#ifdef _DEBUG
						cout<<"CLICOMM_LIST redirecting"<<endl;
						#endif
						if( (sockfd = GetServerConnection(sockfd,servaddr,servtable)) == -1){
							cout<<"Sorry, I cannot connect to any server. Exiting..."<<endl;
							exit(-1);
						} else askforcomm = false;
					}						
					break;
					
					case -3:{  //download andato a male ritentiamo?
						#ifdef _DEBUG
						cout<<"CLICOMM_LIST truncated DL.. retry";
						#endif
						cout<<"Download was truncato (list was NOT updated). Shall I retry [y/n]? ";
						string ans;
						cin>>ans;
						if(ans == "y"){
							askforcomm = false;
							commandstring = "list";
						} else {
							askforcomm = true;
							commandstring = "";
						}
					}
					break;
										
					default:{
						cout<<"unrecoverable error. List not updated"<<endl;
						askforcomm = true;
						commandstring = "";
					}
				}
			}
			break; //fine list command
////////////////
			case CLICOMM_GET:{ //get
#ifdef _DEBUG
cout<<"cleint GET command"<<endl;
#endif
				int result = ExecuteGetCommand(sockfd,filelist,command.arg1,command.arg2,redir_ipaddr,redir_ipport);
#ifdef _DEBUG
cout<<"ExecuteGetCommand returned"<<endl;
#endif
				switch(result){
					case 0:{
						cout<<"file succesfully downloaded!"<<endl;
						askforcomm = true;
						commandstring = "";
					}
					break;
					case -1:{
						cout<<"Watch out the tist, miope uomo... il file non esiste"<<endl;
						askforcomm = true;
						commandstring = "";
					}
					break;
					
					case -2:{
						//fallisce il patteggiamento per il download
						//si dichiara morto il server attuale e si tenta 
						//una nuova connect ad altro server e si riavvia la connessione
						//opzione 1: si mantiene la filelist attuale
												
						if( (sockfd = GetServerConnection(sockfd,servaddr,servtable)) == -1){
							cout<<"Sorry, I cannot connect to any server. Exiting..."<<endl;
							exit(-1);
						} else askforcomm = false; //si esce e si ripete il get...
					}
					break;
					
					case -3:{ //download troncato retry?	 
#ifdef _DEBUG
cout<<"CLICOMM_GET truncated DL.. retry"<<endl;
#endif
						cout<<"Download was truncato. Shall I retry [y/n]? ";
						string ans;
						cin>>ans;
						if(ans == "y") askforcomm = false;
						else {
							askforcomm = true;
							commandstring = "";
						}
					}
					break;
					
					case -4:{ //server ha risposto con deny
						cout<<"File is currently locked. No download allowed."<<endl;
						askforcomm = true;
						commandstring = "";
					}
					break;
					
					case -5:{ //cambiare filename, impossibile aprire il file localmente
						cout<<"File already exists or error opening file"<<endl;
						askforcomm = true;
						commandstring = "";
					}
					break;
					
					case -6:{ //REDIRECT
						cout<<"ADDRESS BOUNCING FOLLOWED!"<<endl;
						/*
						//adesso genero un figlio che temporaneamente mi 
						//gestisce il dl sul server remoto.
						pid_t pid;
						int status;
						if( (pid = fork()) == 0){
							//child
							SA_IN redserver;
							memset(&redserver,0,sizeof(redserver));
							redserver.sin_family = AF_INET;
							redserver.sin_port   = htons(redir_ipport);
							inet_pton(AF_INET,redir_ipaddr.c_str(),&redserver.sin_addr);
							SOCKDESCR redirsockfd = Socket(AF_INET,SOCK_STREAM,0);
							if( (redirsockfd = Reconnect(redirsockfd,(SA *)&redserver,sizeof(redserver),MAX_RESUME_TIME)) == -1){
								cout<<"unable to connect to redirected server. Aborting DL"<<endl;
								exit(-1);
							}  
							//ok collegato!
							//adesso chiamo la procedure ExecuteDL
							//ricorda che il filio ha EREDITATO sia filelist che command
							int redires = ExecuteGetCommand(redirsockfd,filelist,command.arg1,command.arg2,redir_ipaddr,redir_ipport);
							switch(redires){
								case 0:{ //DL OK!!
									string byebyemsg;
									PrepareMessage(CLICOMM_DISCONNECT,byebyemsg);
									SendMsg(redirsockfd,byebyemsg);
									exit(2);
								
								}break;
								
								case -4:{ //DENY
									cout<<"file is currently locked. No DL allowed."<<endl;
									string byebyemsg;
									PrepareMessage(CLICOMM_DISCONNECT,byebyemsg);
									SendMsg(redirsockfd,byebyemsg);
									exit(1);
								}break;
								 
								case -2: { //CONNECTION REFUSED
									cout<<"redirected server refused to connect. aborting DL"<<endl;
									exit(1);
								}break;
								
								case -3: {//truncated
									cout<<"DL truncated. Aborting DL"<<endl;
									string byebyemsg;
									PrepareMessage(CLICOMM_DISCONNECT,byebyemsg);
									SendMsg(redirsockfd,byebyemsg);
									exit(1);
								}break;
								
								default:
									exit(1);
							}
							//ok fine dei giochi
						} else waitpid(pid,&status,0);  //il padre aspetta
						if(WIFEXITED(status) != 0){
							if(WEXITSTATUS(status) != 2)
								cout<<"something was wrong. No file downloaded"<<endl;
						} else cerr<<"child was killed? DL was trunbcated"<<endl;
					*/
					}break;	//fine REDIRECT
					
					default:
						cerr<<"errore non contemplato. Ignoro..."<<endl;
				}//fine switch su
			}break;  //fine CLICOMM_GET				
////////////////////////////////			
			case CLICOMM_PUT: //put
			break;
			case CLICOMM_UPDATE:{
				int result = ExecuteUpdateCommand(sockfd,filelist,command.arg1);
				switch(result){
					case 0:
						cout<<"Ok, buddy, update eseguito!"<<endl;
					break;
					case -1:
						cout<<"Il sever ha risposto che il file e' LOCKED. ritenta... sarai + fortunato"<<endl;
					break;
					case -3:
						cout<<"Non ci siamo con la vista o con le dita: file non nella lista"<<endl;
					break;		
					default:
						cout<<"Sono intervenuti errori irreparabili: Update NON eseguito"<<endl;
				}
				askforcomm = true;
				commandstring = "";	
			}break;
			case CLICOMM_DELETE:  //delete
			break;
			case CLICOMM_DISCONNECT:{  //disconnect
				//close connection socket end exit
				string sendmsg;
				PrepareMessage(CLICOMM_DISCONNECT,sendmsg);
				SendMsg(sockfd,sendmsg);
				cout<<"You are leaving. bye bye"<<endl;
				Close(sockfd);
				sleep(1);
				exit(0);
			}
			break;
			
			case CLICOMM_LOCK:  //lock
			break;
			
			case CLICOMM_SHELL: //esce alla shell
				//creo un figlio ed eseguo una exec
				//attendo per il figlio, non proseguo
			break;
		   case CLICOMM_UNKNOWN:{
		   	askforcomm = true;
		   	commandstring = "";
		   }break;
			default: 
				cout<<"WRONG command. Retype"<<endl;
		}//fine switch sui comandi
	}//fine for;	
}