#include "fedserv.h"
//0 akc received
//-1 timeout
//-2 errori vari
void *broadmsg(void *arg)
{
	Tbroad broad = *((Tbroad *)arg);
	delete arg;
	
	SA_IN addr;
	memset(&addr,0,sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_port   = htons(broad.port);
	inet_pton(AF_INET,broad.addr.c_str(),&addr.sin_addr);
	
	SOCKDESCR connsock = Socket(AF_INET,SOCK_STREAM,0);
	if(( connsock = Reconnect(connsock,(SA *)&addr,sizeof(addr),MAX_RESUME_TIME)) == -1){
		cerr<<"broad: cannot connettere"<<endl;
		Tbroadstatus *pstat = new(Tbroadstatus);
		pstat->name = broad.name;
		pstat->status = -2;
		pthread_exit((void *)pstat);
	}
	if(SendMsg(connsock,broad.msg) == -1)
	{
		cerr<<"broad: cannot send"<<endl;
		Tbroadstatus *pstat = new(Tbroadstatus);
		pstat->name = broad.name;
		pstat->status = -2;
		pthread_exit((void *)pstat);
	}
	string recvmsg; 
	if(RecvMsg(connsock,recvmsg) == -1)
	{
		cerr<<"broad: cannot receive"<<endl;
		Tbroadstatus *pstat = new(Tbroadstatus);
		pstat->name = broad.name;
		pstat->status = -2;
		pthread_exit((void *)pstat);
	}
	Tclicomm clicomm;
#ifdef _DEBUG
cout<<"broadmsg: received msg: "<<recvmsg<<endl;
#endif
	ProcessMessageForServer(SERVER_COMMAND,recvmsg,clicomm);
	switch(clicomm.msg_type){
		case ACK:{
			Tbroadstatus *pstat = new(Tbroadstatus);
			pstat->name = broad.name;
			pstat->status = 0;
#ifdef _DEBUG
cout<<"broadmsg: ACK correctly received exiting: "<<recvmsg<<endl;
#endif
		 	pthread_exit((void *)pstat);
		 }break;
		 default:{
		 	cerr<<"broad: messaggio non riconosciuto"<<endl;
			Tbroadstatus *pstat = new(Tbroadstatus);
			pstat->name = broad.name;
			pstat->status = -2;
			pthread_exit((void *)pstat);
		}
	}
}
//--------------
int cache_invalidate_broadcast(string filename)
{
	//leggo il serverdb. dall'inizio e mando a tutti un messaggio
	//attendo risposte
	serverdb.SetPosition(0);
	vector<pthread_t> tidvector;
	string invmsg;
	PrepareMessage(SERV_CACHE_INV,filename,invmsg);
	for(int j = 0; j < serverdb.Size(); j++){
		serverrecord rec = serverdb.Get(); //
		Tbroad *pbroad = new(Tbroad);
		pbroad->name = rec.name;
		pbroad->addr = rec.ipaddr; 
		pbroad->port = rec.serverport;
		pbroad->msg  = invmsg;
		pthread_t tid;
#ifdef _DEBUG
cout<<"cache_invalidate: name,ipaddr,serverport,invmsg"<<pbroad->name<<pbroad->addr<<pbroad->port<<pbroad->msg<<endl;
#endif
		pthread_create(&tid,NULL,broadmsg,(void *)pbroad);
		tidvector.push_back(tid);
	}
	//adesso implemento la barriera con riexecute della broadmsg
	//se necessario
	for(unsigned int j = 0; j < tidvector.size(); j++){
		Tbroadstatus *pstatus;
		pthread_join(tidvector[j],(void **)&pstatus);
#ifdef _DEBUG
cout<<"cache_invalidate: examining returned status"<<recvmsg<<endl;
#endif
		if(pstatus->status == -1){
			//resend
			Tbroad *pbroad = new(Tbroad);
			pbroad->name = pstatus->name; 
			pbroad->addr = serverdb.GetAddr(pstatus->name); 
			pbroad->port = serverdb.GetServerPort(pstatus->name);;
			pbroad->msg  = invmsg;
			pthread_t tid;
			pthread_create(&tid,NULL,broadmsg,(void *)pbroad);
			tidvector.push_back(tid);
		}
	}
	return 0;
	//ok se sono qui tutti gli ack ricevuti		
}
//--------------------------------------------
//0 OWNERSHIP PASSED
//-1 denied pass
//-2 unrec errors
int passownerproto(string filename, string addr,int port,int numofaccess)
{
	//mi collego alla SERVER_TO_SERVER_PORT
	SA_IN serveraddr;
	memset(&serveraddr,0,sizeof(serveraddr));
	serveraddr.sin_family = AF_INET;
	serveraddr.sin_port   = htons(port);
	inet_pton(AF_INET,addr.c_str(),&serveraddr.sin_addr);

	//devo gestire il bouncing
	int restarted = 0;
	bool filedb_was_modified = false;
	
	while(restarted < MAX_PSOPROTO_RESTART){		
		memset(&serveraddr,0,sizeof(serveraddr));
		serveraddr.sin_family = AF_INET;
		serveraddr.sin_port   = htons(port);
		inet_pton(AF_INET,addr.c_str(),&serveraddr.sin_addr);

		SOCKDESCR connsock = Socket(AF_INET,SOCK_STREAM,0);
		if( (connsock = Reconnect(connsock,(SA *)&serveraddr,sizeof(serveraddr),MAX_RESUME_TIME)) == -1){
			cerr<<"I CANNOT connect to server for pass ownership"<<endl;
			return -2;
		}
		//ok connesso
		string msgtosend;
		ostringstream os; os<<numofaccess;
		PrepareMessage(SERV_PASS_OWNERSHIP,filename,os.str(),msgtosend);
		if(SendMsg(connsock,msgtosend) == -1){
			cerr<<"passownerproto: i cannot send first msg"<<endl;
			return -2;
		}
		string recvmsg;
		if(RecvMsg(connsock,recvmsg) == -1){
			cerr<<"passownerproto: I cannot recv message"<<endl;
			return -2;
		}
		Tclicomm clicomm;
		ProcessMessageForServer(SERVER_COMMAND,recvmsg,clicomm);
		switch(clicomm.msg_type){
			case ACK:{ //ho raggiunto il server che ha l'ownership
				//ho ricevuto ACK1
				//applico OWNED
				string localaddr = GetIPAddr(connsock,LOCAL_ENDPOINT);
				pthread_mutex_lock(&serverdb_mutex);
				string localname = serverdb.GetNameFromAddr(localaddr);
				pthread_mutex_unlock(&serverdb_mutex);
				
				pthread_mutex_lock(&filedb_mutex);
				filedb.SetFileLocation(filename,OWNED);
				filedb.SetFileOwner(filename,localname);
				pthread_mutex_unlock(&filedb_mutex);
				filedb_was_modified = true;
				//spedisco ACK2
				string ack2msg;
				PrepareMessage(SERV_SIMPLE_ACK,ack2msg);
				if(SendMsg(connsock,ack2msg) == -1){
					cerr<<"PSOproto:impossibile spedire ACK2.restarting protocol"<<endl;
					restarted++;
					Close(connsock);
				}else{
					//ack2 sent, aspetto per ack3
					string ack3msg;
					if(RecvMsg(connsock,ack3msg) == -1){
						cerr<<"PSOproto: impossible ricevere ACK3. restarting proto"<<endl;
						restarted++;
						Close(connsock);
					}else{
						//protocollo concluso corretamente
						Close(connsock);
#ifdef _DEBUG
cout<<"PSO proto concluso degnamente... ;-)"<<endl;
#endif
						return 0;
					}
				}
			}break;
			
			case NOT_OWN:{
				//il protocollo e' stato riavviato ma entrambe le
				//parti hanno raggiunto uno stato globalmente consistente
				Close(connsock);
				return 0;
			}break;
			
			case DENY:
				return -1;
			break;
			case REDIR:{ //gestisco il bouncing...
				Close(connsock);
				addr = clicomm.arg1;
				istringstream is(clicomm.arg2);
				is>>port;
			}break;		
			default:{
				cerr<<"passownerproto: messaggio ricevuto NON contemplato errore di progr"<<endl;
				return -2;
			}
		}
	}
}

//-------------------------------
void *servergetrequest(void *arg)
{
	pthread_detach(pthread_self());
	Tserverget *pget = (Tserverget *)arg;
	string filename = pget->filename;
	string serverstraddr = pget->addr;
	int serverport = pget->port;
	delete arg;
	
	//qui devo chiamare la ExecuteClientGet....
	ostringstream os;
	os<<CACHING_TEMP_FILENAME<<filename;
	string tempfilename = os.str();
	vector<string> templist;
	if(!filedb.GetList(templist)){
		cerr<<"errore nella GetList di servergetreq"<<endl;
		pthread_exit(0);
	}
	//ok adesso dobbiamo creare una connessione *camuffando* il server da
	//client
	
	SA_IN serveraddr;
	string redir_ipaddr = serverstraddr;
	int    redir_ipport  = serverport;

#ifdef _DEBUG
cout<<"caching routine... connect to ip: "<<serverstraddr<<":"<<serverport<<endl;
#endif
	
	bool finished = false;
	while(!finished){
		memset(&serveraddr,0,sizeof(serveraddr));
		serveraddr.sin_family = AF_INET;
		serveraddr.sin_port = htons(redir_ipport);
		inet_pton(AF_INET,redir_ipaddr.c_str(),&serveraddr.sin_addr);
	
		SOCKDESCR connsock = Socket(AF_INET,SOCK_STREAM,0);
		if( (connsock = Reconnect(connsock,(SA *)&serveraddr,sizeof(serveraddr),MAX_RESUME_TIME)) == -1){
			cerr<<"I cannot connect for caching file "<<filename<<". Caching aborted"<<endl;
			pthread_exit(0);
		}
			
		int result = ExecuteGetCommand(connsock,templist,filename,tempfilename, redir_ipaddr,redir_ipport);
		switch(result){
	
			case 0:{  //good download
				finished = true;
				string byebyemsg;
				PrepareMessage(CLICOMM_DISCONNECT,byebyemsg);
				SendMsg(connsock,byebyemsg); 
				Close(connsock);
				//adesso devo rinominare il file e mettere il flag CACHED nella location
				pthread_mutex_lock(&filedb_mutex);
				filedb.SetFileLock(filename);
				filedb.SetFileLocation(filename,CACHED);
				pthread_mutex_unlock(&filedb_mutex);
				//copiamo il file nel filename corretto
				int byteread = -1;
				char copybuffer[MAX_COPYBUFFER_LEN];
				umask(0);
				int sourcefd = open(tempfilename.c_str(),O_RDONLY);
				int destfd = open(filename.c_str(),O_CREAT|O_WRONLY,S_IRWXU);
				bool remove =false;
				while( (byteread = read(sourcefd,copybuffer,MAX_COPYBUFFER_LEN)) > 0)
					if(write(destfd,copybuffer,MAX_COPYBUFFER_LEN) < byteread){
						cerr<<"error copying cached file: removing from cache"<<endl;
						remove = true;
					}	
				close(sourcefd);
				close(destfd);
				if(remove){  //durante la copia locale qualche cosa e' andato male
					pthread_mutex_lock(&filedb_mutex);
					filedb.SetFileLocation(filename,REMOTE);
					filedb.RemoveFileLock(filename);
					pthread_mutex_unlock(&filedb_mutex);
				}else{
					pthread_mutex_lock(&filedb_mutex);
					filedb.RemoveFileLock(filename);
					pthread_mutex_unlock(&filedb_mutex);
				}
			}break;
		
			case -6:{ //REDIR received
				string byebyemsg;
				PrepareMessage(CLICOMM_DISCONNECT,byebyemsg);
				SendMsg(connsock,byebyemsg);
				Close(connsock);
				//ora devo anche agiornare la l' indirizzo dell' owner
				pthread_mutex_lock(&filedb_mutex);
				if(!filedb.SetFileOwner(filename,redir_ipaddr)){
					cerr<<"Non posso chanbiare l'owner per il redirect. Aborting caching"<<endl;
					finished =true;
				}
				pthread_mutex_unlock(&filedb_mutex);		
			}break;
		
			default:{ //impossibile cachare ;-) il file: aborting
				string byebyemsg;
				PrepareMessage(CLICOMM_DISCONNECT,byebyemsg);
				SendMsg(connsock,byebyemsg);
				Close(connsock);
				finished = true;
			}
		}//case
	}//while
	pthread_exit(0);

}	
//-----------------------------------------
void *ClientToServer(void *arg)
{
	
	pthread_detach(pthread_self());
	
	SOCKDESCR connsock = *((SOCKDESCR *)arg);
	delete arg;
	
	//adesso una connessione e' stata stabilita, si attende
	//per un comando:
	for(;;){
		cout<<"waiting for client command"<<endl;
		string recvcommand;
		if(RecvMsg(connsock,recvcommand) == -1){
			cerr<<"I got a bad command. I am gonna discard it"<<endl;
#ifdef _DEBUG
exit(-1);
#endif
		}else{
			Tclicomm clicomm;
			ProcessMessageForServer(CLIENT_COMMAND,recvcommand,clicomm);
			switch(clicomm.msg_type){
				case LST_MSG:{
#ifdef _DEBUG
cout<<"executing LST_MSG"<<endl;
#endif
					//il client richiede l'aggiornamento del file.db
					//1) acquisisco l'accesso a filelist (attraverso la mutex)
					//1bis) oppure allo scadere del timeout rispondo con DENY
					//2) aggiorno il file.db su disco
					//3) copio il file.db in un file temporaneo e memorizzo la len
					//4) RILASCIO la MUTEX
					//5) apro la socket di FT
					//6) comunico al client "ACK <porta> <filelen> <EOL>
					//7) attivo la procedure FT lato server
					//8) ritorno a "pollare" i comandi
				
					//1)il processo e' sospeso finche' la mutex non e' rilasciata
					pthread_mutex_lock(&filedb_mutex);
					//2) -> 3)
					filedb.UpdateToDisk();
					filedb.ExtractFileListToDisk(SERVER_FILELIST_TEMP_NAME);
					//4)
					pthread_mutex_unlock(&filedb_mutex);
					struct stat filestat;
					if(stat(SERVER_FILELIST_TEMP_NAME,&filestat) == -1){
						cerr<<"errore nella chiamata a stat su SERVER_FILELIST_TEMP_NAME"<<endl;
						string sendmsg;
						PrepareMessage(SERV_DENY,sendmsg);
						SendMsg(connsock,sendmsg);
					}else{
						//5)
						SA_IN tempaddr,clientaddr;
						socklen_t tempaddrlen, clientaddrlen;
						getsockname(connsock,(SA *)&tempaddr,&tempaddrlen);
						getpeername(connsock,(SA *)&clientaddr,&clientaddrlen);
						tempaddr.sin_family = AF_INET;
						//tempaddr.sin_addr.s_addr = clientaddr.sin_addr; //solo il cliente attuale
						SOCKDESCR FTlistensock = Socket(AF_INET,SOCK_STREAM,0);
						int listenport = Rebind(FTlistensock,&tempaddr,tempaddrlen,EPHE_LOW_BOUND,EPHE_HIGH_BOUND);
						if(!Listen(FTlistensock,MAXLISTEN)){
							cerr<<"UNABLE to put up listen socket. Aborting"<<endl;
							pthread_exit(0);
						}
						string sendmsg;
						//6)
						ostringstream os2,os1;
						os2<<filestat.st_size;
						os1<<listenport;
						PrepareMessage(SERV_GET_ACK,os1.str(),os2.str(),sendmsg);
#ifdef _DEBUG
cout<<"sending FTmsg: "<<sendmsg<<endl;
#endif
						SendMsg(connsock,sendmsg);
						//7)chiamo la FTprocedure
						FTServerProcedure(FTlistensock,SERVER_FILELIST_TEMP_NAME,filestat.st_size,0);
						//in ogni caso tutte le sock aperte sono chiuse
#ifdef _DEBUG
cout<<"FINISHED downloadind list"<<endl;
#endif
					}//fine else;
				}break;// fine LST_MSG;
	
				case GET_MSG:{
					// in repl.arg1 c'e'il filename richiesto
					// 1 accedo a filelist (in mutex)
					// 2 ne controllo prima lo stato e poi l' ownership
					// 3A se cached e valid (cioe'location != cached) allora gestisco
					//      localmente il dl
					// 3B se NON cached e numovaccess < CACHE_THRESHOLD spedisco un bel REDIR
					//      al client (accedo in mutex al serverdb)
					// 3C se NON cached e numofaccess >= CACE_THRESHOLD attivo la FTserver procedure
					//     e contemporaneamente lancio lo thread per la connessione in GET server server
					string filename = clicomm.arg1;
					pthread_mutex_lock(&filedb_mutex);
					switch(filedb.GetFileLocation(filename)){
						case REMOTE:{
#ifdef _DEBUG
cout<<"server GET_MSG: prepare REDIR"<<endl;
#endif
							bool must_i_cache = false;
							//ok preparo REDIR ricavando
							string remoteservername = filedb.GetFileOwner(filename);
							string remoteserverip = serverdb.GetAddr(remoteservername);
							filedb.IncrementNumOfAccess(filename);
							if(filedb.GetNumOfAccess(filename) > CACHE_THRESHOLD)
								must_i_cache = true;
							pthread_mutex_unlock(&filedb_mutex);
							pthread_mutex_lock(&serverdb_mutex);
							int remoteport = serverdb.GetPort(remoteservername);
							pthread_mutex_unlock(&serverdb_mutex);
							ostringstream os; os<<remoteport;
							string sendmsg;
							PrepareMessage(SERV_REDIR,remoteserverip,os.str(),sendmsg);
							SendMsg(connsock,sendmsg);
							//quando ritorna la message (timeout o completion) vediamo se
							if(must_i_cache){
								//metto in esecuzione il download-thread verso il server
								//owner. tale thread deve portare a termine il DL (gestendo)
								//l'eventuale REDIR del former owner
								Tserverget *pserverget = new(Tserverget);
								pserverget->filename = filename;
								pserverget->addr = remoteserverip;
								pserverget->port = remoteport;
								pthread_t tid;
							
								pthread_create(&tid,NULL,servergetrequest,(void *)pserverget); 
							}
						}break;
						
						case CACHED:
							//se CACHED ==> copia valida!
							//se arriva un INV_CAC command da un server
							//la location viene messa a REMOTE.
						case OWNED:{
							//1)verifico se il file e'locked
							//2A) se si ->DENY, break
							//2B)	altrimenti estraggo le stat e chiamo la ftprocedure
							//qui il LOCK e' ancora trattenuto(vedi switch)
							
							filedb.IncrementNumOfAccess(filename);
							bool locked = filedb.IsFileLocked(filename);
							pthread_mutex_unlock(&filedb_mutex);
							if(locked){
								string sendmsg;
								PrepareMessage(SERV_DENY,sendmsg);
								SendMsg(connsock,sendmsg);
							}else{
								struct stat filestat;
								if(stat(filename.c_str(),&filestat) == -1){
									cerr<<"errore nella chiamata a stat sul filename"<<endl;
									string sendmsg;
									PrepareMessage(SERV_DENY,sendmsg);
									SendMsg(connsock,sendmsg);
								}else{
									SA_IN tempaddr;
									//SA_IN clientaddr;
																		
									string strtempaddr = GetIPAddr(connsock,LOCAL_ENDPOINT);
									string strclientaddr = GetIPAddr(connsock,PEER_ENDPOINT);
									tempaddr.sin_family = AF_INET;
									inet_pton(AF_INET,strtempaddr.c_str(),&tempaddr.sin_addr);
									//inet_pton(AF_INET,strclientaddr.c_str(),tempaddr.sin_addr.s_addr);
									
									//tempaddr.sin_addr.s_addr = clientaddr.sin_addr; //solo il cliente attuale
									
									SOCKDESCR FTlistensock = Socket(AF_INET,SOCK_STREAM,0);
									socklen_t tempaddrlen = sizeof(tempaddr);
									int listenport = Rebind(FTlistensock,&tempaddr,tempaddrlen,EPHE_LOW_BOUND,EPHE_HIGH_BOUND);
									if(!Listen(FTlistensock,MAXLISTEN)){
										cerr<<"UNABLE to put up listen socket. Aborting"<<endl;
										pthread_exit(0);
									}
									string sendmsg;
									ostringstream os2,os1;
									os2<<filestat.st_size;
									os1<<listenport;
									PrepareMessage(SERV_GET_ACK,os1.str(),os2.str(),sendmsg);
									SendMsg(connsock,sendmsg);
									//chiamo la FTprocedure
									FTServerProcedure(FTlistensock,filename,filestat.st_size,0);
									//in ogni caso tutte le sock aperte sono chiuse
								}//fine else;						
							}//else
						}break;	
						
						default:
							cerr<<"fedserv_proc: GET_MSG: location non riconosciuta"<<endl;
					}//
				}break;  //fine GET
				
				case UNC_MSG:{ //update!!!!!!!!!!!
					//ora devo vedere se
					//A(1) sono owner
					//B(2) NON sono owner e NumOfAccess < FETCH_ON_WRITE_THRESHOLD
					//C(3) NON sono owner ma richiedo un PASS OWNERSHIP (>FETCH_ON_WRITE_...)
					//D(4) NON owner NON cached ma #numof access diventa == CACHED_THRESHOLD
				   string filename = clicomm.arg1;
				   int situazione = 0;
				   pthread_mutex_lock(&filedb_mutex);
				   filedb.IncrementNumOfAccess(filename);
				   int numofacc = filedb.GetNumOfAccess(filename);
				   int location = filedb.GetFileLocation(filename);
				   switch(location){
				   	case OWNED:
				   		situazione = 1;
				   	break;
				   	case CACHED:{
				   		if(numofacc >= FETCH_ON_WRITE_THRESHOLD) situazione = 3;
				   		else situazione = 2;
				   	}break;
				   	case REMOTE:
				   	case NONE:{
				   		if(numofacc < CACHE_THRESHOLD) situazione = 2;
				   		else if((numofacc >= CACHE_THRESHOLD)&&(numofacc < FETCH_ON_WRITE_THRESHOLD))
				   				situazione = 4;  //readahed
				   			else situazione = 3;
				   	}break;
				   	default:
				   		cerr<<"SERVER UPDATE:location del file NON prevista..."<<endl;
				   }
				  
				   /*
				   if(filedb.GetFileLocation(filename) == OWNED) situazione = 1;
				   else	if(numofacc < CACHE_THRESHOLD) situazione = 2;
				   	else if((numofacc >= CACHE_THRESHOLD)&&(numofacc < FETCH_ON_WRITE_THRESHOLD)) situazione = 4;
				   		else if(numofacc >= FETCH_ON_WRITE_THRESHOLD) situazione = 3;
				  */
				  
#ifdef _DEBUG
cout<<"SITUAZIONE RICONOSCIUTA: "<<situazione<<endl;
if((situazione != 1)&&(situazione != 2)&&(situazione != 3)&&(situazione!=4))
cout<<"SERVER UPDATE PROC: errore nella colonna if else. SOMARO!"<<endl;
#endif  								
					pthread_mutex_unlock(&filedb_mutex);				   
					switch(situazione){
						case 1:{ //OWNER
							pthread_mutex_lock(&filedb_mutex);
							if(filedb.IsFileLocked(filename)){
								pthread_mutex_unlock(&filedb_mutex);
								string denymsg;
#ifdef _DEBUG
cout<<"UPDATE: sending DENY:  "<<denymsg<<endl;
#endif
								PrepareMessage(SERV_DENY,denymsg);
								SendMsg(connsock,denymsg);
							}else{
								//inviamo un cache invalidate
								//al termine del quale comunichiamo
								//l'ack e modifichiamo il file (fittizio)
								pthread_mutex_unlock(&filedb_mutex);
								//*********************
#ifdef _DEBUG
cout<<"UPDATE: moving to cache invalidate broadcast"<<endl;
#endif	
								cache_invalidate_broadcast(filename);
								//**********************
								//ok, adesso applichiamo le modifiche
								pthread_mutex_lock(&filedb_mutex);
								filedb.SetFileLock(filename);
								pthread_mutex_unlock(&filedb_mutex);
								//*********
								sleep(SIMULA_UPDATE); //simula la fase di updatre;
								cout<<"eseguito update su file: "<<filename<<endl;
								//**********
								pthread_mutex_lock(&filedb_mutex);
								filedb.RemoveFileLock(filename);
								pthread_mutex_unlock(&filedb_mutex);
								string ackmsg;
								PrepareMessage(SERV_SIMPLE_ACK,ackmsg);
								SendMsg(connsock,ackmsg);
							}
						}break;
						case 2:{ //NO CACHE,NO FETCH, semplice REDIR
							pthread_mutex_lock(&filedb_mutex);
							string remoteservername = filedb.GetFileOwner(filename);
							pthread_mutex_unlock(&filedb_mutex);
							pthread_mutex_lock(&serverdb_mutex);
							string remoteserveraddr = serverdb.GetAddr(remoteservername);
							int    remoteserverport = serverdb.GetPort(remoteservername);
							pthread_mutex_unlock(&serverdb_mutex);
							string sendmsg;
							ostringstream os;
							os<<remoteserverport;
							PrepareMessage(SERV_REDIR,remoteserveraddr,os.str(),sendmsg);
#ifdef _DEBUG
cout<<"server update:REDIR msg: "<<sendmsg<<endl;
#endif				
							SendMsg(connsock,sendmsg);
							//ricevo l'ack finale dal client
							string discard;
							RecvMsg(connsock,discard);
						}break;							
						case 3:{ //FETCH ON WRITE con PASS OWNERSHIP
							//OK qui richiedo l'ownership
							pthread_mutex_lock(&filedb_mutex);
							int numofaccess = filedb.GetNumOfAccess(filename);
							string remotename = filedb.GetFileOwner(filename);
							filedb.SetFileLock(filename);
							pthread_mutex_unlock(&filedb_mutex);
							pthread_mutex_lock(&serverdb_mutex);
							string remoteaddr = serverdb.GetAddr(remotename);
							int    remoteport = serverdb.GetServerPort(remotename);
							pthread_mutex_unlock(&serverdb_mutex);
							//****************************
#ifdef _DEBUG
cout<<"SERVER UPDATE: BOOP!"<<endl;
#endif						
							int passresult = passownerproto(filename,remoteaddr,remoteport,numofaccess);
							//********************************
							switch(passresult){
								case 0:{ //ownership acquired
								//il file e' locked RICORDA!
									//**************
									cache_invalidate_broadcast(filename);
									//**************
									//ok, adesso applichiamo le modifiche
									sleep(SIMULA_UPDATE); //simula la fase di updatre;
									pthread_mutex_lock(&filedb_mutex);
									filedb.SetFileLocation(filename,OWNED);
									filedb.RemoveFileLock(filename);
									pthread_mutex_unlock(&filedb_mutex);
									string ackmsg;
									PrepareMessage(SERV_SIMPLE_ACK,ackmsg);
									SendMsg(connsock,ackmsg);
								}break;
								case -1: //il server owner ha risposto con deny
								case -2:{ //errori irrecuperabili
									pthread_mutex_lock(&filedb_mutex);
									filedb.RemoveFileLock(filename);
									string denymsg;
									PrepareMessage(SERV_DENY,denymsg);
									SendMsg(connsock,denymsg);
								}break;
								default:
									cerr<<"fedserv_proc UNC_MSG, passownerproto result sconosciuto"<<endl;
							}
						}break;
						case 4:{ //NO CACHED -> CACHED (READ AHEAD)
							//(A) inviamo un REDIR e attendiamo l' ACK del CLIENT
							//attiviamo poi un download e settiamo a cached la location
							pthread_mutex_lock(&filedb_mutex);
							string remoteservername = filedb.GetFileOwner(filename);
							pthread_mutex_unlock(&filedb_mutex);
							pthread_mutex_lock(&serverdb_mutex);
							string remoteserveraddr = serverdb.GetAddr(remoteservername);
							int    remoteserverport = serverdb.GetPort(remoteservername);
							pthread_mutex_unlock(&serverdb_mutex);
							string sendmsg;
							ostringstream os; os<<remoteserverport;
							PrepareMessage(SERV_REDIR,remoteserveraddr,os.str(),sendmsg);
							SendMsg(connsock,sendmsg);
							//ricevo l'ack finale dal client
							string recvack;
							RecvMsg(connsock,recvack);
							Tclicomm repl;
							ProcessMessageForServer(CLIENT_COMMAND,recvack,repl);
							//se ACK -> cachamo; se DENY -> lasciamo perdere
							if((unsigned int)repl.msg_type == ACK){						
								Tserverget *pserverget = new(Tserverget);
								pserverget->filename = filename;
								pserverget->addr = remoteserveraddr;
								pserverget->port = remoteserverport;
								pthread_t tid;
								pthread_create(&tid,NULL,servergetrequest,(void *)pserverget); 
							}					
						}break;
						default:
							cerr<<"fedserv_proc: UNC_MSG: aituazione NON riconosciuta"<<endl;
					}				
				}break;
				case UPD_MSG:{
					//qui giunge una richiesta di update rediretta
					//devo estire solo il REDIR o L'UPDATE locale
					string filename = clicomm.arg1;
					//disctinguiamo solo 2 casi: OWNER/NON_OWNER
					
					pthread_mutex_lock(&filedb_mutex);
					int location = filedb.GetFileLocation(filename);
					bool locked = filedb.IsFileLocked(filename);
					string remoteservername = filedb.GetFileOwner(filename);
					pthread_mutex_unlock(&filedb_mutex);
					if(location == OWNED){
						if(locked){
							string denymsg;
							PrepareMessage(SERV_DENY,denymsg);
							SendMsg(connsock,denymsg);
						}else{
							//OK applico le modifiche localmente e
							//e mando un CAC_IV agli altri server e un 
							//ACK al client
							//***
							cache_invalidate_broadcast(filename);
							//***
							//***
							pthread_mutex_lock(&filedb_mutex);
							filedb.SetFileLock(filename);
							pthread_mutex_unlock(&filedb_mutex);
							sleep(SIMULA_UPDATE);
							cout<<"Updated file: "<<filename<<endl;
							pthread_mutex_lock(&filedb_mutex);
							filedb.RemoveFileLock(filename);
							pthread_mutex_unlock(&filedb_mutex);
							string ackmsg;
							PrepareMessage(SERV_SIMPLE_ACK,ackmsg);
							SendMsg(connsock,ackmsg);
						}
					}else{
						//prepariamo il solito redir
						pthread_mutex_lock(&serverdb_mutex);
						string remoteserveraddr = serverdb.GetAddr(remoteservername);
						int    remoteserverport = serverdb.GetPort(remoteservername);
						pthread_mutex_unlock(&serverdb_mutex);
						string sendmsg;
						ostringstream os; os<<remoteserverport;
						PrepareMessage(SERV_REDIR,remoteserveraddr,os.str(),sendmsg);
						SendMsg(connsock,sendmsg);
						//string discard;
						//RecvMsg(connsock,discard);
					}	
				}break; 
							
				case PUT_MSG:
				case DLT_MSG:
				case LCK_MSG:{
					///ffffffffffff
				}break;
				
				case DCT_MSG:{ //il client abbandona la connessione
#ifdef _DEBUG
cout<<"client disconnected. closing thread"<<endl;
#endif
					Close(connsock);
					pthread_exit(0);
				}break;
				default:
					cerr<<"fedserver_proc.cpp: messaggio del cliente non riconosciutio"<<endl;
			}//main switch
		}//if-else
	}//forever
}
///////////------------------------------------------------
int ManagePSO(SOCKDESCR connsock,string filename, int remote_numofacc)
{
	//bisogna implementare un ack di ritorno
	//per applicare effettivamente il nuovo owner.
	if(filedb.IsFileLocked(filename)){
		string sendmsg;
		PrepareMessage(SERV_DENY,sendmsg);
		SendMsg(connsock,sendmsg);
		Close(connsock);
		return 0;
	}
	
	pthread_mutex_lock(&filedb_mutex);                        //**lock
	int location = filedb.GetFileLocation(filename);
	string remoteservername = filedb.GetFileOwner(filename);				//**unlock
	pthread_mutex_unlock(&filedb_mutex);
	pthread_mutex_lock(&serverdb_mutex);
	string remoteserveraddr = serverdb.GetAddr(remoteservername);
	int    remoteserverport = serverdb.GetServerPort(remoteservername);
	pthread_mutex_unlock(&serverdb_mutex);
	if(location != OWNED){					
		if(remoteserveraddr == GetIPAddr(connsock,PEER_ENDPOINT)){
			//significa che chi sta richiedendo un OPP e' proprietario
			//del file, cioe' sto gestendo il caso in cui non sia giunto
			//all' altro l' ACK3
			string sendmsg;
			PrepareMessage(SERV_NOTOWNED,sendmsg);
			SendMsg(connsock,sendmsg);
			Close(connsock);
			return 0;
		}else{
			//qui devo gestire il redir: il file non e' posseduto echi mi
			//fa un PSO non e' il proprietario
			string redirmsg;
			ostringstream os; os<<remoteserverport;
			PrepareMessage(SERV_REDIR,remoteserveraddr,os.str(),redirmsg);
			SendMsg(connsock,redirmsg);
			Close(connsock);
			return 0;
		}
	}
	int local_numofacc = filedb.GetNumOfAccess(filename);
	filedb.SetFileLock(filename);
	pthread_mutex_unlock(&filedb_mutex);                          //**unlock
	if(local_numofacc >= remote_numofacc + DELTA_ACCESS){
		string denymsg;
		PrepareMessage(SERV_DENY,denymsg);
		//spedisco il DENY
#ifdef _DEBUG
cout<<"BOPP: owner dice NO al OPP"<<endl;
#endif
		SendMsg(connsock,denymsg);
		Close(connsock);
		return 0;
	}else{
		//spedisco ACK1 ----
		string replyack;
		PrepareMessage(SERV_SIMPLE_ACK,replyack);
		if(SendMsg(connsock,replyack) == -1){
			cerr<<"ManagePSO: unable to send ACK1"<<endl;
			Close(connsock);
			return -1;
		}	
#ifdef _DEBUG
cout<<"BOPP: spedito ACK1"<<endl;
#endif
		string recvack;
		//ricevo ACK2
		if(RecvMsg(connsock,recvack) == -1){
			cerr<<"ManagePSO: unable to receive ACK2"<<endl;
			Close(connsock);
			return -1;
		}
#ifdef _DEBUG
cout<<"BOPP: ricevuto ACK2"<<endl;
#endif
		//applico la REMOTE;
		string newowneraddr = GetIPAddr(connsock,PEER_ENDPOINT);
		pthread_mutex_lock(&serverdb_mutex);
		string newownername = serverdb.GetNameFromAddr(newowneraddr);
		pthread_mutex_unlock(&serverdb_mutex);
		pthread_mutex_lock(&filedb_mutex);
		filedb.SetFileLocation(filename,REMOTE);
		filedb.SetFileOwner(filename,newownername);
		filedb.RemoveFileLock(filename);
		pthread_mutex_unlock(&filedb_mutex);
		PrepareMessage(SERV_SIMPLE_ACK,replyack);
		//spedisco ACK3
		SendMsg(connsock,replyack);
#ifdef _DEBUG
cout<<"BOPP: aggiornato filedbe spedito ACK3"<<endl;
#endif
		return 0;
	}
}				