#include "msgprocessing.h"

const string sp = " ";

int PrepareMessage(unsigned int command_id, string par, string &msg)
{
	return PrepareMessage(command_id,par,"",msg);
}
//---------------------------------------
int PrepareMessage(unsigned int command_id, string &msg)
{
	return PrepareMessage(command_id,"","",msg);
}
//---------------------------------------
int PrepareMessage(unsigned int command_id, string par1, string par2, string &msg)
{
	ostringstream os;
	switch(command_id){
		case CLICOMM_LIST:{
			os<<LST_MSG<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		} break;
		case CLICOMM_GET:{
			os<<GET_MSG<<sp<<par1<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		} break;
		case CLICOMM_PUT:{
			os<<PUT_MSG<<sp<<par1<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		} break;
		case CLICOMM_UPDATE:{
			os<<UPD_MSG<<sp<<par1<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		} break;
		case CLICOMM_UPDATE_WITH_CACHE:{
			os<<UNC_MSG<<sp<<par1<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		}break;
		case CLICOMM_DELETE:{
			os<<DLT_MSG<<sp<<par1<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		} break;
		case CLICOMM_LOCK:{
			os<<LCK_MSG<<sp<<par1<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		} break;
		case CLICOMM_DISCONNECT:{
			os<<DCT_MSG<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		}break;
		//----------------------------------------
		//----------------------------------------
		case SERV_SIMPLE_ACK:{
			os<<ACK<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		}break;
		case SERV_GET_ACK:{
			//par1 = listensock fo FT
			//par2 = filelen
			os<<ACK<<sp<<par1<<sp<<par2<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		}break;
		case SERV_REDIR:{
			//par1: ipaddr
			//par2: port
			os<<REDIR<<sp<<par1<<sp<<par2<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		}break;
		case SERV_DENY:{
			os<<DENY<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		} break;
		case SERV_CACHE_INV:{
			os<<CAC_INV<<sp<<par1<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
			return 0;
		}break;
		case SERV_PASS_OWNERSHIP:{
			os<<PSO_MSG<<sp<<par1<<sp<<par2<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
		}break;
		case SERV_NOTOWNED:{
			os<<NOT_OWN<<sp<<FILEDB_END_OF_LINE;
			msg = os.str();
		}break;
		default:{
			cerr<<"errore: command_id/message_id NON identificato:"<<endl;
			return -1;
		}	
	}
}
//-----------------------------------------------------------------
//-----------------------------------------------------------------
//-----------------------------------------------------------------
bool GoodEnd(string check)
{
	if(check != FILEDB_END_OF_LINE){
		cerr<<"messaggio NON riconosciuto"<<endl;
		return false;
	} else return true;
}	

int ProcessMessageForClient(unsigned int command_id, string msg, Trepl &repl)
{
	istringstream is(msg);
	int msg_id;
	string check = "";
	switch(command_id){
		case CLICOMM_LIST:{
			is>>msg_id;
			switch(msg_id){
				case ACK:{
					repl.msg_type = msg_id;
					is>>repl.port; is>>repl.filelen; is>>check;
					if(!GoodEnd(check)) repl.msg_type = UNKN;
					return 0;
				} break;
				case DENY:{
					repl.msg_type = msg_id;
					is>>check;
					if(!GoodEnd(check)) repl.msg_type = UNKN;
					return 0;
				} break;
				default:{
					cerr<<"message UNKNOWN"<<endl;
					repl.msg_type = UNKN;
				}
			}
		}break; //fine clicomm_list
		case CLICOMM_GET:{
			is>>msg_id; 
			switch(msg_id){
				case ACK:{
					repl.msg_type = msg_id;
					is>>repl.port; is>>repl.filelen; is>>check;
					if(!GoodEnd(check)) repl.msg_type = UNKN;
					return 0;
				} break;
				case DENY:{
					repl.msg_type = msg_id;
					is>>check;
					if(!GoodEnd(check)) repl.msg_type = UNKN;
					return 0;
				} break;
				case REDIR:{
					repl.msg_type = msg_id;
					is>>repl.ipaddr; is>>repl.port; is>>check;
					if(!GoodEnd(check)) repl.msg_type = UNKN;
					return 0;
				} break;
				default:{
					cerr<<"message UNKNOWN"<<endl;
					repl.msg_type = UNKN;
				}
			}
		}break; //fine clicomm_get
		case CLICOMM_DELETE:
		case CLICOMM_LOCK:
		case CLICOMM_UPDATE:{
			is>>msg_id;
			switch(msg_id){
				case ACK:{
					repl.msg_type = msg_id;
					is>>check;
					if(!GoodEnd(check)) repl.msg_type = UNKN;
					return 0;
				}break;	
				case DENY:{
					repl.msg_type = msg_id;
					is>>check;
					if(!GoodEnd(check)) repl.msg_type = UNKN;
					return 0;
				}break;
				case REDIR:{
					repl.msg_type = msg_id;
					is>>repl.ipaddr; is>>repl.port; is>>check;
					if(!GoodEnd(check)) repl.msg_type = UNKN;
					return 0;
				}break;
				default:{
					cerr<<"message UNKNOWN"<<endl;
					repl.msg_type = UNKN;
				}
			}
		}break;
		default:{
			cerr<<"errore di programmazione in ProcessMessage"<<endl;
			exit(-1);
		}
	}
}
//--------------------------------------------------
int ProcessMessageForServer(unsigned int phase_id, string msg, Tclicomm &clicomm)
{
	istringstream is(msg);
	int msg_id;
	string check = "";
	switch(phase_id){
		case CLIENT_COMMAND:{
			is>>msg_id;
			switch(msg_id){
				case GET_MSG:
				case PUT_MSG:
				case UPD_MSG:
				case UNC_MSG:
				case DLT_MSG:
				case LCK_MSG:{
					clicomm.msg_type = msg_id;
					is>>clicomm.arg1; is>>check;
					if(!GoodEnd(check)) clicomm.msg_type = UNKN;
					return 0;
				}break;
				case LST_MSG:
				case ACK:      //***** attenzione!
				case DCT_MSG:{
#ifdef _DEBUG
cout<<"process message for server. received: "<<msg_id<<endl;
#endif
					clicomm.msg_type = msg_id;
					is>>check;
					if(!GoodEnd(check)) clicomm.msg_type = UNKN;
					return 0;
				}break;
				default:{
					cerr<<"message UNKNOWN"<<endl;
					clicomm.msg_type = UNKN;
				}
			}//
		}//fine client_command
		case SERVER_COMMAND:{
			is>>msg_id;
			switch(msg_id){
				case PSO_MSG:{
					clicomm.msg_type = msg_id;
					is>>clicomm.arg1; is>>clicomm.arg2; is>>check;
					if(!GoodEnd(check)) clicomm.msg_type = UNKN;
					return 0;
				}break;
				case CAC_INV:{
					clicomm.msg_type = msg_id;
					is>>clicomm.arg1; is>>check;
					if(!GoodEnd(check)) clicomm.msg_type = UNKN;
					return 0;
				}break;
				case ACK:{
					clicomm.msg_type = msg_id;
					is>>check;
					if(!GoodEnd(check)) clicomm.msg_type = UNKN;
					return 0;
				}break;
				case REDIR:{
					clicomm.msg_type = msg_id;
					is>>clicomm.arg1; is>>clicomm.arg2; is>>check;
					if(!GoodEnd(check)) clicomm.msg_type = UNKN;
					return 0;
				}break;
				default:{
					cerr<<"message UNKNOWN"<<endl;
					clicomm.msg_type = UNKN;
				}
			}
		}break; //server_command
		default:{
			cerr<<"ProcessMessageForServer: ERRORE DI PROGRAMMAZIONE! STUPIDO!"<<endl;
			exit(-1);
		}
	}//fine main switch
}//fine funzione
						
					