#ifndef _PROCFILE
#define _PROCFILE
#endif

#ifndef _PROJECT
#include "project.h"
#endif

#include "sstream.h"
#include <algorithm>
#ifndef _DEBUG
#define _DEBUG
#endif

typedef struct {
	string filename;
	int    status;
	int    location;
	string owner;
	int    numofaccess;
} filerecord;

class Tfiledb {
	vector<filerecord>   recordlist;  //vettore dei record dei file
	bool                 modified;    //modificato e NON salvato su disco
	string               filedbname;  //nome del filedb (DEFAULT: file.db)    
	
	bool _loadfrom(void);
	bool _writeto(void);
	bool _writeto(string filename);
	vector<filerecord>::iterator _findname(string  filename);
	
public:
	bool       GetList(vector<string> &filenamelist) const;
	bool       ExtractFileListToDisk(string filename) const;
	int        Size(void) const;
	bool       Insert(string filename, int status, int location, string owner, int numofaccess);
	bool       Delete(string filename);
	bool       Find(string filename);
	int        GetFileStatus(string filename);
	int        GetFileLocation(string filename);
	string     GetFileOwner(string filename);
	int        GetNumOfAccess(string filename);
	bool       IsFileLocked(string filename);
	bool       SetFileLock(string filename);
	bool       RemoveFileLock(string filename);
	bool       SetFileStatus(string filename, int newstatus);
	bool       SetFileLocation(string filename, int newlocation);
	bool       SetFileOwner(string filename, string newowner);
	int        IncrementNumOfAccess(string filename);
	bool       UpdateToDisk(void);
	bool       MakeCopyToDisk(string filename);
                   Tfiledb(string filename);
	           Tfiledb(void);
	          //~Tfiledb(void);
};
//-----------------
typedef struct{
	string name;
	string ipaddr;
	int    port;         //server to client port
	int    serverport;   //server to server port
	int    status;
}serverrecord;

class Tserverdb{
	vector<serverrecord> recordvector;
	bool                 modified;
	string               serverdbname;
	int                  currentindex;
	
	bool _loadfrom(void);
	bool _writeto(void);
public:
	             Tserverdb(string filename);
	             Tserverdb(void);
	            //~Tserverdb(void);	  			//NI
	
	bool         Insert(serverrecord record, int position); //NI
	bool         Delete(int position);			//NI
	bool         Delete(serverrecord);			//NI 
	int          GetPosition(serverrecord record);		//NI
	int          Size(void);
	string       GetAddr(string name) const;
	int          GetPort(string name) const;
	int          GetServerPort(string name) const;
	string       GetNameFromAddr(string addr) const;
	int          Size(void) const;
	serverrecord Get(void);
	int          SetPosition(int position);
};

//-------------------------------------------------
//riservato al client
typedef struct{
	string ip_addr;
	int    port;
}servrecord;

typedef vector<servrecord> Tservtable;

bool FillServTable(Tservtable &servtable, string filename);
//-----------------------------------------------